##// END OF EJS Templates
a
Unknown -
r489:54e2ae4a5bc6
parent child
Show More
@@ -1,859 +1,864
1 #!/bin/sh
1 #!/bin/sh
2 ########################################################################
2 ########################################################################
3 # rpi23-gen-image.sh 2015-2017
3 # rpi23-gen-image.sh 2015-2017
4 #
4 #
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 #
6 #
7 # This program is free software; you can redistribute it and/or
7 # This program is free software; you can redistribute it and/or
8 # modify it under the terms of the GNU General Public License
8 # modify it under the terms of the GNU General Public License
9 # as published by the Free Software Foundation; either version 2
9 # as published by the Free Software Foundation; either version 2
10 # of the License, or (at your option) any later version.
10 # of the License, or (at your option) any later version.
11 #
11 #
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 #
13 #
14 # Big thanks for patches and enhancements by 20+ github contributors!
14 # Big thanks for patches and enhancements by 20+ github contributors!
15 ########################################################################
15 ########################################################################
16
16
17 # Are we running as root?
17 # Are we running as root?
18 if [ "$(id -u)" -ne "0" ] ; then
18 if [ "$(id -u)" -ne "0" ] ; then
19 echo "error: this script must be executed with root privileges!"
19 echo "error: this script must be executed with root privileges!"
20 exit 1
20 exit 1
21 fi
21 fi
22
22
23 # Check if ./functions.sh script exists
23 # Check if ./functions.sh script exists
24 if [ ! -r "./functions.sh" ] ; then
24 if [ ! -r "./functions.sh" ] ; then
25 echo "error: './functions.sh' required script not found!"
25 echo "error: './functions.sh' required script not found!"
26 exit 1
26 exit 1
27 fi
27 fi
28
28
29 # Load utility functions
29 # Load utility functions
30 . ./functions.sh
30 . ./functions.sh
31
31
32 # Load parameters from configuration template file
32 # Load parameters from configuration template file
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 use_template
34 use_template
35 fi
35 fi
36
36
37 # Introduce settings
37 # Introduce settings
38 set -e
38 set -e
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 set -x
40 set -x
41
41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration
43 RPI_MODEL=${RPI_MODEL:=2}
43 RPI_MODEL=${RPI_MODEL:=2}
44
44
45 # Debian release
45 # Debian release
46 RELEASE=${RELEASE:=buster}
46 RELEASE=${RELEASE:=buster}
47
47
48 # Kernel Branch
48 # Kernel Branch
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50
50
51 # URLs
51 # URLs
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62
62
63 # Kernel deb packages for 32bit kernel
63 # Kernel deb packages for 32bit kernel
64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
64 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
65 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
66 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
67 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
68 # Default precompiled 64bit kernel
68 # Default precompiled 64bit kernel
69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
69 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
70 # Generic
70 # Generic
71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
71 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
72
72
73 # Build directories
73 # Build directories
74 WORKDIR=$(pwd)
74 WORKDIR=$(pwd)
75 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
75 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
76 BUILDDIR="${BASEDIR}/build"
76 BUILDDIR="${BASEDIR}/build"
77
77
78 # Chroot directories
78 # Chroot directories
79 R="${BUILDDIR}/chroot"
79 R="${BUILDDIR}/chroot"
80 ETC_DIR="${R}/etc"
80 ETC_DIR="${R}/etc"
81 LIB_DIR="${R}/lib"
81 LIB_DIR="${R}/lib"
82 BOOT_DIR="${R}/boot/firmware"
82 BOOT_DIR="${R}/boot/firmware"
83 KERNEL_DIR="${R}/usr/src/linux"
83 KERNEL_DIR="${R}/usr/src/linux"
84 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
84 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
85 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
85 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
86
86
87 # Firmware directory: Blank if download from github
87 # Firmware directory: Blank if download from github
88 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
88 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
89
89
90 # General settings
90 # General settings
91 SET_ARCH=${SET_ARCH:=32}
91 SET_ARCH=${SET_ARCH:=32}
92 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
92 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
93 PASSWORD=${PASSWORD:=raspberry}
93 PASSWORD=${PASSWORD:=raspberry}
94 USER_PASSWORD=${USER_PASSWORD:=raspberry}
94 USER_PASSWORD=${USER_PASSWORD:=raspberry}
95 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
95 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
96 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
96 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
97 EXPANDROOT=${EXPANDROOT:=true}
97 EXPANDROOT=${EXPANDROOT:=true}
98
98
99 # Keyboard settings
99 # Keyboard settings
100 XKB_MODEL=${XKB_MODEL:=""}
100 XKB_MODEL=${XKB_MODEL:=""}
101 XKB_LAYOUT=${XKB_LAYOUT:=""}
101 XKB_LAYOUT=${XKB_LAYOUT:=""}
102 XKB_VARIANT=${XKB_VARIANT:=""}
102 XKB_VARIANT=${XKB_VARIANT:=""}
103 XKB_OPTIONS=${XKB_OPTIONS:=""}
103 XKB_OPTIONS=${XKB_OPTIONS:=""}
104
104
105 # Network settings (DHCP)
105 # Network settings (DHCP)
106 ENABLE_DHCP=${ENABLE_DHCP:=true}
106 ENABLE_DHCP=${ENABLE_DHCP:=true}
107
107
108 # Network settings (static)
108 # Network settings (static)
109 NET_ADDRESS=${NET_ADDRESS:=""}
109 NET_ADDRESS=${NET_ADDRESS:=""}
110 NET_GATEWAY=${NET_GATEWAY:=""}
110 NET_GATEWAY=${NET_GATEWAY:=""}
111 NET_DNS_1=${NET_DNS_1:=""}
111 NET_DNS_1=${NET_DNS_1:=""}
112 NET_DNS_2=${NET_DNS_2:=""}
112 NET_DNS_2=${NET_DNS_2:=""}
113 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
113 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
114 NET_NTP_1=${NET_NTP_1:=""}
114 NET_NTP_1=${NET_NTP_1:=""}
115 NET_NTP_2=${NET_NTP_2:=""}
115 NET_NTP_2=${NET_NTP_2:=""}
116
116
117 # APT settings
117 # APT settings
118 APT_PROXY=${APT_PROXY:=""}
118 APT_PROXY=${APT_PROXY:=""}
119 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
119 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
120
120
121 # Feature settings
121 # Feature settings
122 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
122 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
123 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
123 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
124 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
124 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
125 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
125 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
126 ENABLE_I2C=${ENABLE_I2C:=false}
126 ENABLE_I2C=${ENABLE_I2C:=false}
127 ENABLE_SPI=${ENABLE_SPI:=false}
127 ENABLE_SPI=${ENABLE_SPI:=false}
128 ENABLE_IPV6=${ENABLE_IPV6:=true}
128 ENABLE_IPV6=${ENABLE_IPV6:=true}
129 ENABLE_SSHD=${ENABLE_SSHD:=true}
129 ENABLE_SSHD=${ENABLE_SSHD:=true}
130 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
130 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
131 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
131 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
132 ENABLE_SOUND=${ENABLE_SOUND:=true}
132 ENABLE_SOUND=${ENABLE_SOUND:=true}
133 ENABLE_DBUS=${ENABLE_DBUS:=true}
133 ENABLE_DBUS=${ENABLE_DBUS:=true}
134 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
134 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
135 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
135 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
136 ENABLE_XORG=${ENABLE_XORG:=false}
136 ENABLE_XORG=${ENABLE_XORG:=false}
137 ENABLE_WM=${ENABLE_WM:=""}
137 ENABLE_WM=${ENABLE_WM:=""}
138 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
138 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
139 ENABLE_USER=${ENABLE_USER:=true}
139 ENABLE_USER=${ENABLE_USER:=true}
140 USER_NAME=${USER_NAME:="pi"}
140 USER_NAME=${USER_NAME:="pi"}
141 ENABLE_ROOT=${ENABLE_ROOT:=false}
141 ENABLE_ROOT=${ENABLE_ROOT:=false}
142 ENABLE_QEMU=${ENABLE_QEMU:=false}
142 ENABLE_QEMU=${ENABLE_QEMU:=false}
143 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
143 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
144
144
145 # SSH settings
145 # SSH settings
146 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
146 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
147 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
147 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
148 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
148 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
149 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
149 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
150 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
150 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
151
151
152 # Advanced settings
152 # Advanced settings
153 ENABLE_SYSTEMDSWAP=${ENABLE_MINBASE:=false}
153 ENABLE_SYSTEMDSWAP=${ENABLE_MINBASE:=false}
154 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
154 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
155 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
155 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
156 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
156 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
157 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
157 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
158 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
158 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
159 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
159 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
160 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
160 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
161 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
161 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
162 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
162 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
163 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
163 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
164 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
164 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
165 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
165 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
166 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
166 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
167 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
167 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
168 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
168 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
169 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
169 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
170 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
170 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
171
171
172 # Kernel compilation settings
172 # Kernel compilation settings
173 BUILD_KERNEL=${BUILD_KERNEL:=true}
173 BUILD_KERNEL=${BUILD_KERNEL:=true}
174 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
174 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
175 KERNEL_THREADS=${KERNEL_THREADS:=1}
175 KERNEL_THREADS=${KERNEL_THREADS:=1}
176 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
176 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
177 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
177 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
178 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
178 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
179 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
179 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
180 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
180 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
181 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
181 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
182 KERNEL_VIRT=${KERNEL_VIRT:=false}
182 KERNEL_VIRT=${KERNEL_VIRT:=false}
183 KERNEL_BPF=${KERNEL_BPF:=false}
183 KERNEL_BPF=${KERNEL_BPF:=false}
184 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=POWERSAVE}
184 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=POWERSAVE}
185
185
186 # Kernel compilation from source directory settings
186 # Kernel compilation from source directory settings
187 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
187 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
188 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
188 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
189 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
189 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
190 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
190 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
191
191
192 # Reduce disk usage settings
192 # Reduce disk usage settings
193 REDUCE_APT=${REDUCE_APT:=true}
193 REDUCE_APT=${REDUCE_APT:=true}
194 REDUCE_DOC=${REDUCE_DOC:=true}
194 REDUCE_DOC=${REDUCE_DOC:=true}
195 REDUCE_MAN=${REDUCE_MAN:=true}
195 REDUCE_MAN=${REDUCE_MAN:=true}
196 REDUCE_VIM=${REDUCE_VIM:=false}
196 REDUCE_VIM=${REDUCE_VIM:=false}
197 REDUCE_BASH=${REDUCE_BASH:=false}
197 REDUCE_BASH=${REDUCE_BASH:=false}
198 REDUCE_HWDB=${REDUCE_HWDB:=true}
198 REDUCE_HWDB=${REDUCE_HWDB:=true}
199 REDUCE_SSHD=${REDUCE_SSHD:=true}
199 REDUCE_SSHD=${REDUCE_SSHD:=true}
200 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
200 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
201
201
202 # Encrypted filesystem settings
202 # Encrypted filesystem settings
203 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
203 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
204 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
204 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
205 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
205 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
206 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
206 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
207 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
207 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
208 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
208 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
209 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
209 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
210 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
210 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
211 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
211 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
212
212
213 # Chroot scripts directory
213 # Chroot scripts directory
214 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
214 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
215
215
216 # Packages required in the chroot build environment
216 # Packages required in the chroot build environment
217 APT_INCLUDES=${APT_INCLUDES:=""}
217 APT_INCLUDES=${APT_INCLUDES:=""}
218 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
218 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
219
219
220 #Packages to exclude from chroot build environment
220 #Packages to exclude from chroot build environment
221 APT_EXCLUDES=${APT_EXCLUDES:=""}
221 APT_EXCLUDES=${APT_EXCLUDES:=""}
222
222
223 # Packages required for bootstrapping
223 # Packages required for bootstrapping
224 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
224 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
225 MISSING_PACKAGES=""
225 MISSING_PACKAGES=""
226
226
227 # Packages installed for c/c++ build environment in chroot (keep empty)
227 # Packages installed for c/c++ build environment in chroot (keep empty)
228 COMPILER_PACKAGES=""
228 COMPILER_PACKAGES=""
229
229
230 #Check if apt-cacher-ng has port 3142 open and set APT_PROXY
230 #Check if apt-cacher-ng has port 3142 open and set APT_PROXY
231 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
231 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
232 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
232 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
233 APT_PROXY=http://127.0.0.1:3142/
233 APT_PROXY=http://127.0.0.1:3142/
234 fi
234 fi
235
235
236 #netselect-apt does not know buster yet
236 #netselect-apt does not know buster yet
237 if [ "$RELEASE" = "buster" ] ; then
237 if [ "$RELEASE" = "buster" ] ; then
238 RLS=testing
238 RLS=testing
239 else
239 else
240 RLS="$RELEASE"
240 RLS="$RELEASE"
241 fi
241 fi
242
242
243 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
243 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
244 rm "$(pwd)/files/apt/sources.list"
244 rm "$(pwd)/files/apt/sources.list"
245 fi
245 fi
246
246
247 if [ "$ENABLE_NONFREE" = true ] ; then
247 if [ "$ENABLE_NONFREE" = true ] ; then
248 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
248 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
249 else
249 else
250 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
250 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
251 fi
251 fi
252
252
253 #sed and cut the result string so we can use it as APT_SERVER
253 #sed and cut the result string so we can use it as APT_SERVER
254 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
254 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
255
255
256 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
256 #make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
257 if [ -n "$SET_ARCH" ] ; then
257 if [ -n "$SET_ARCH" ] ; then
258 # 64-bit configuration
258 # 64-bit configuration
259 if [ "$SET_ARCH" = 64 ] ; then
259 if [ "$SET_ARCH" = 64 ] ; then
260 # General 64-bit depended settings
260 # General 64-bit depended settings
261 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
261 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
262 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
262 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
263 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
263 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
264
264
265 # Raspberry Pi model specific settings
265 # Raspberry Pi model specific settings
266 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
266 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
267 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
268 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
268 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
269 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
269 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
270 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
270 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
271 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
271 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
272 else
272 else
273 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
273 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
274 exit 1
274 exit 1
275 fi
275 fi
276 fi
276 fi
277
277
278 # 32-bit configuration
278 # 32-bit configuration
279 if [ "$SET_ARCH" = 32 ] ; then
279 if [ "$SET_ARCH" = 32 ] ; then
280 # General 32-bit dependend settings
280 # General 32-bit dependend settings
281 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
281 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
282 KERNEL_ARCH=${KERNEL_ARCH:=arm}
282 KERNEL_ARCH=${KERNEL_ARCH:=arm}
283 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
283 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
284
284
285 # Raspberry Pi model specific settings
285 # Raspberry Pi model specific settings
286 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
286 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
287 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
287 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
288 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
288 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
289 RELEASE_ARCH=${RELEASE_ARCH:=armel}
289 RELEASE_ARCH=${RELEASE_ARCH:=armel}
290 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
290 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
291 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
291 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
292 fi
292 fi
293
293
294 # Raspberry Pi model specific settings
294 # Raspberry Pi model specific settings
295 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
295 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
296 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
296 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
297 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
297 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
298 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
298 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
299 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
299 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
300 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
300 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
301 fi
301 fi
302 fi
302 fi
303 #SET_ARCH not set
303 #SET_ARCH not set
304 else
304 else
305 echo "error: Please set '32' or '64' as value for SET_ARCH"
305 echo "error: Please set '32' or '64' as value for SET_ARCH"
306 exit 1
306 exit 1
307 fi
307 fi
308 # Device specific configuration and U-Boot configuration
308 # Device specific configuration and U-Boot configuration
309 case "$RPI_MODEL" in
309 case "$RPI_MODEL" in
310 0)
310 0)
311 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
311 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
312 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
312 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
313 ;;
313 ;;
314 1)
314 1)
315 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
315 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
316 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
316 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
317 ;;
317 ;;
318 1P)
318 1P)
319 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
319 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
320 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
321 ;;
321 ;;
322 2)
322 2)
323 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
323 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
324 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
325 ;;
325 ;;
326 3)
326 3)
327 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
327 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
328 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
329 ;;
329 ;;
330 3P)
330 3P)
331 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
331 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
332 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
333 ;;
333 ;;
334 *)
334 *)
335 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
335 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
336 exit 1
336 exit 1
337 ;;
337 ;;
338 esac
338 esac
339
339
340 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
340 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
341 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
341 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
342 # Include bluetooth packages on supported boards
342 # Include bluetooth packages on supported boards
343 if [ "$ENABLE_BLUETOOTH" = true ] ; then
343 if [ "$ENABLE_BLUETOOTH" = true ] ; then
344 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
344 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
345 fi
345 fi
346 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
346 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
347 # Check if the internal wireless interface is not supported by the RPi model
347 # Check if the internal wireless interface is not supported by the RPi model
348 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
348 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
349 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
349 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
350 exit 1
350 exit 1
351 fi
351 fi
352 fi
352 fi
353
353
354 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
354 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
355 echo "error: You have to compile kernel sources, if you want to enable nexmon"
355 echo "error: You have to compile kernel sources, if you want to enable nexmon"
356 exit 1
356 exit 1
357 fi
357 fi
358
358
359 # Prepare date string for default image file name
359 # Prepare date string for default image file name
360 DATE="$(date +%Y-%m-%d)"
360 DATE="$(date +%Y-%m-%d)"
361 if [ -z "$KERNEL_BRANCH" ] ; then
361 if [ -z "$KERNEL_BRANCH" ] ; then
362 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
362 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
363 else
363 else
364 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
364 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
365 fi
365 fi
366
366
367 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
367 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
368 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
368 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
369 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
369 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
370 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
370 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
371 exit 1
371 exit 1
372 fi
372 fi
373 fi
373 fi
374
374
375 set +x
375 set +x
376
376
377 # Add cmake to compile videocore sources
377 # Add cmake to compile videocore sources
378 if [ "$ENABLE_VIDEOCORE" = true ] ; then
378 if [ "$ENABLE_VIDEOCORE" = true ] ; then
379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
379 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
380 fi
380 fi
381
381
382 # Add deps for nexmon
382 # Add deps for nexmon
383 if [ "$ENABLE_NEXMON" = true ] ; then
383 if [ "$ENABLE_NEXMON" = true ] ; then
384 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
384 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
385 fi
385 fi
386
386
387 # Add libncurses5 to enable kernel menuconfig
387 # Add libncurses5 to enable kernel menuconfig
388 if [ "$KERNEL_MENUCONFIG" = true ] ; then
388 if [ "$KERNEL_MENUCONFIG" = true ] ; then
389 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
389 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
390 fi
390 fi
391
391
392 # Add ccache compiler cache for (faster) kernel cross (re)compilation
392 # Add ccache compiler cache for (faster) kernel cross (re)compilation
393 if [ "$KERNEL_CCACHE" = true ] ; then
393 if [ "$KERNEL_CCACHE" = true ] ; then
394 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
394 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
395 fi
395 fi
396
396
397 # Add cryptsetup package to enable filesystem encryption
397 # Add cryptsetup package to enable filesystem encryption
398 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
398 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
399 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
399 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
400 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
400 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
401
401
402 #If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
402 #If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
403 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
403 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
404 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
404 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
405 fi
405 fi
406
406
407 if [ -z "$CRYPTFS_PASSWORD" ] ; then
407 if [ -z "$CRYPTFS_PASSWORD" ] ; then
408 echo "error: no password defined (CRYPTFS_PASSWORD)!"
408 echo "error: no password defined (CRYPTFS_PASSWORD)!"
409 exit 1
409 exit 1
410 fi
410 fi
411 ENABLE_INITRAMFS=true
411 ENABLE_INITRAMFS=true
412 fi
412 fi
413
413
414 # Add initramfs generation tools
414 # Add initramfs generation tools
415 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
415 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
416 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
416 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
417 fi
417 fi
418
418
419 # Add device-tree-compiler required for building the U-Boot bootloader
419 # Add device-tree-compiler required for building the U-Boot bootloader
420 if [ "$ENABLE_UBOOT" = true ] ; then
420 if [ "$ENABLE_UBOOT" = true ] ; then
421 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
421 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
422 else
422 else
423 if [ "$ENABLE_UBOOTUSB" = true ] ; then
423 if [ "$ENABLE_UBOOTUSB" = true ] ; then
424 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
424 echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
425 exit 1
425 exit 1
426 fi
426 fi
427 fi
427 fi
428
428
429 # Check if root SSH (v2) public key file exists
429 # Check if root SSH (v2) public key file exists
430 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
430 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
431 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
431 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
432 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
432 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
433 exit 1
433 exit 1
434 fi
434 fi
435 fi
435 fi
436
436
437 # Check if $USER_NAME SSH (v2) public key file exists
437 # Check if $USER_NAME SSH (v2) public key file exists
438 if [ -n "$SSH_USER_PUB_KEY" ] ; then
438 if [ -n "$SSH_USER_PUB_KEY" ] ; then
439 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
439 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
440 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
440 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
441 exit 1
441 exit 1
442 fi
442 fi
443 fi
443 fi
444
444
445 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
446 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
447 exit 1
448 fi
449
445 # Check if all required packages are installed on the build system
450 # Check if all required packages are installed on the build system
446 for package in $REQUIRED_PACKAGES ; do
451 for package in $REQUIRED_PACKAGES ; do
447 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
452 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
448 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
453 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
449 fi
454 fi
450 done
455 done
451
456
452 # If there are missing packages ask confirmation for install, or exit
457 # If there are missing packages ask confirmation for install, or exit
453 if [ -n "$MISSING_PACKAGES" ] ; then
458 if [ -n "$MISSING_PACKAGES" ] ; then
454 echo "the following packages needed by this script are not installed:"
459 echo "the following packages needed by this script are not installed:"
455 echo "$MISSING_PACKAGES"
460 echo "$MISSING_PACKAGES"
456
461
457 printf "\ndo you want to install the missing packages right now? [y/n] "
462 printf "\ndo you want to install the missing packages right now? [y/n] "
458 read -r confirm
463 read -r confirm
459 [ "$confirm" != "y" ] && exit 1
464 [ "$confirm" != "y" ] && exit 1
460
465
461 # Make sure all missing required packages are installed
466 # Make sure all missing required packages are installed
462 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
467 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
463 fi
468 fi
464
469
465 # Check if ./bootstrap.d directory exists
470 # Check if ./bootstrap.d directory exists
466 if [ ! -d "./bootstrap.d/" ] ; then
471 if [ ! -d "./bootstrap.d/" ] ; then
467 echo "error: './bootstrap.d' required directory not found!"
472 echo "error: './bootstrap.d' required directory not found!"
468 exit 1
473 exit 1
469 fi
474 fi
470
475
471 # Check if ./files directory exists
476 # Check if ./files directory exists
472 if [ ! -d "./files/" ] ; then
477 if [ ! -d "./files/" ] ; then
473 echo "error: './files' required directory not found!"
478 echo "error: './files' required directory not found!"
474 exit 1
479 exit 1
475 fi
480 fi
476
481
477 # Check if specified KERNELSRC_DIR directory exists
482 # Check if specified KERNELSRC_DIR directory exists
478 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
483 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
479 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
484 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
480 exit 1
485 exit 1
481 fi
486 fi
482
487
483 # Check if specified UBOOTSRC_DIR directory exists
488 # Check if specified UBOOTSRC_DIR directory exists
484 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
489 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
485 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
490 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
486 exit 1
491 exit 1
487 fi
492 fi
488
493
489 # Check if specified VIDEOCORESRC_DIR directory exists
494 # Check if specified VIDEOCORESRC_DIR directory exists
490 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
495 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
491 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
496 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
492 exit 1
497 exit 1
493 fi
498 fi
494
499
495 # Check if specified FBTURBOSRC_DIR directory exists
500 # Check if specified FBTURBOSRC_DIR directory exists
496 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
501 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
497 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
502 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
498 exit 1
503 exit 1
499 fi
504 fi
500
505
501 # Check if specified NEXMONSRC_DIR directory exists
506 # Check if specified NEXMONSRC_DIR directory exists
502 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
507 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
503 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
508 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
504 exit 1
509 exit 1
505 fi
510 fi
506
511
507 # Check if specified CHROOT_SCRIPTS directory exists
512 # Check if specified CHROOT_SCRIPTS directory exists
508 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
513 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
509 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
514 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
510 exit 1
515 exit 1
511 fi
516 fi
512
517
513 # Check if specified device mapping already exists (will be used by cryptsetup)
518 # Check if specified device mapping already exists (will be used by cryptsetup)
514 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
519 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
515 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
520 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
516 exit 1
521 exit 1
517 fi
522 fi
518
523
519 # Don't clobber an old build
524 # Don't clobber an old build
520 if [ -e "$BUILDDIR" ] ; then
525 if [ -e "$BUILDDIR" ] ; then
521 echo "error: directory ${BUILDDIR} already exists, not proceeding"
526 echo "error: directory ${BUILDDIR} already exists, not proceeding"
522 exit 1
527 exit 1
523 fi
528 fi
524
529
525 # Setup chroot directory
530 # Setup chroot directory
526 mkdir -p "${R}"
531 mkdir -p "${R}"
527
532
528 # Check if build directory has enough of free disk space >512MB
533 # Check if build directory has enough of free disk space >512MB
529 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
534 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
530 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
535 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
531 exit 1
536 exit 1
532 fi
537 fi
533
538
534 set -x
539 set -x
535
540
536 # Call "cleanup" function on various signals and errors
541 # Call "cleanup" function on various signals and errors
537 trap cleanup 0 1 2 3 6
542 trap cleanup 0 1 2 3 6
538
543
539 # Add required packages for the minbase installation
544 # Add required packages for the minbase installation
540 if [ "$ENABLE_MINBASE" = true ] ; then
545 if [ "$ENABLE_MINBASE" = true ] ; then
541 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
546 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
542 fi
547 fi
543
548
544 # Add parted package, required to get partprobe utility
549 # Add parted package, required to get partprobe utility
545 if [ "$EXPANDROOT" = true ] ; then
550 if [ "$EXPANDROOT" = true ] ; then
546 APT_INCLUDES="${APT_INCLUDES},parted"
551 APT_INCLUDES="${APT_INCLUDES},parted"
547 fi
552 fi
548
553
549 # Add dbus package, recommended if using systemd
554 # Add dbus package, recommended if using systemd
550 if [ "$ENABLE_DBUS" = true ] ; then
555 if [ "$ENABLE_DBUS" = true ] ; then
551 APT_INCLUDES="${APT_INCLUDES},dbus"
556 APT_INCLUDES="${APT_INCLUDES},dbus"
552 fi
557 fi
553
558
554 # Add iptables IPv4/IPv6 package
559 # Add iptables IPv4/IPv6 package
555 if [ "$ENABLE_IPTABLES" = true ] ; then
560 if [ "$ENABLE_IPTABLES" = true ] ; then
556 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
561 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
557 fi
562 fi
558
563
559 # Add openssh server package
564 # Add openssh server package
560 if [ "$ENABLE_SSHD" = true ] ; then
565 if [ "$ENABLE_SSHD" = true ] ; then
561 APT_INCLUDES="${APT_INCLUDES},openssh-server"
566 APT_INCLUDES="${APT_INCLUDES},openssh-server"
562 fi
567 fi
563
568
564 # Add alsa-utils package
569 # Add alsa-utils package
565 if [ "$ENABLE_SOUND" = true ] ; then
570 if [ "$ENABLE_SOUND" = true ] ; then
566 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
571 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
567 fi
572 fi
568
573
569 # Add rng-tools package
574 # Add rng-tools package
570 if [ "$ENABLE_HWRANDOM" = true ] ; then
575 if [ "$ENABLE_HWRANDOM" = true ] ; then
571 APT_INCLUDES="${APT_INCLUDES},rng-tools"
576 APT_INCLUDES="${APT_INCLUDES},rng-tools"
572 fi
577 fi
573
578
574 # Add fbturbo video driver
579 # Add fbturbo video driver
575 if [ "$ENABLE_FBTURBO" = true ] ; then
580 if [ "$ENABLE_FBTURBO" = true ] ; then
576 # Enable xorg package dependencies
581 # Enable xorg package dependencies
577 ENABLE_XORG=true
582 ENABLE_XORG=true
578 fi
583 fi
579
584
580 # Add user defined window manager package
585 # Add user defined window manager package
581 if [ -n "$ENABLE_WM" ] ; then
586 if [ -n "$ENABLE_WM" ] ; then
582 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
587 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
583
588
584 # Enable xorg package dependencies
589 # Enable xorg package dependencies
585 ENABLE_XORG=true
590 ENABLE_XORG=true
586 fi
591 fi
587
592
588 # Add xorg package
593 # Add xorg package
589 if [ "$ENABLE_XORG" = true ] ; then
594 if [ "$ENABLE_XORG" = true ] ; then
590 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
595 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
591 fi
596 fi
592
597
593 # Replace selected packages with smaller clones
598 # Replace selected packages with smaller clones
594 if [ "$ENABLE_REDUCE" = true ] ; then
599 if [ "$ENABLE_REDUCE" = true ] ; then
595 # Add levee package instead of vim-tiny
600 # Add levee package instead of vim-tiny
596 if [ "$REDUCE_VIM" = true ] ; then
601 if [ "$REDUCE_VIM" = true ] ; then
597 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
602 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
598 fi
603 fi
599
604
600 # Add dropbear package instead of openssh-server
605 # Add dropbear package instead of openssh-server
601 if [ "$REDUCE_SSHD" = true ] ; then
606 if [ "$REDUCE_SSHD" = true ] ; then
602 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
607 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
603 fi
608 fi
604 fi
609 fi
605
610
606 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
611 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
607 if [ "$ENABLE_SYSVINIT" = false ] ; then
612 if [ "$ENABLE_SYSVINIT" = false ] ; then
608 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
613 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
609 fi
614 fi
610
615
611 # Configure kernel sources if no KERNELSRC_DIR
616 # Configure kernel sources if no KERNELSRC_DIR
612 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
617 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
613 KERNELSRC_CONFIG=true
618 KERNELSRC_CONFIG=true
614 fi
619 fi
615
620
616 # Configure reduced kernel
621 # Configure reduced kernel
617 if [ "$KERNEL_REDUCE" = true ] ; then
622 if [ "$KERNEL_REDUCE" = true ] ; then
618 KERNELSRC_CONFIG=false
623 KERNELSRC_CONFIG=false
619 fi
624 fi
620
625
621 # Configure qemu compatible kernel
626 # Configure qemu compatible kernel
622 if [ "$ENABLE_QEMU" = true ] ; then
627 if [ "$ENABLE_QEMU" = true ] ; then
623 DTB_FILE=vexpress-v2p-ca15_a7.dtb
628 DTB_FILE=vexpress-v2p-ca15_a7.dtb
624 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
629 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
625 KERNEL_DEFCONFIG="vexpress_defconfig"
630 KERNEL_DEFCONFIG="vexpress_defconfig"
626 if [ "$KERNEL_MENUCONFIG" = false ] ; then
631 if [ "$KERNEL_MENUCONFIG" = false ] ; then
627 KERNEL_OLDDEFCONFIG=true
632 KERNEL_OLDDEFCONFIG=true
628 fi
633 fi
629 fi
634 fi
630
635
631 # Execute bootstrap scripts
636 # Execute bootstrap scripts
632 for SCRIPT in bootstrap.d/*.sh; do
637 for SCRIPT in bootstrap.d/*.sh; do
633 head -n 3 "$SCRIPT"
638 head -n 3 "$SCRIPT"
634 . "$SCRIPT"
639 . "$SCRIPT"
635 done
640 done
636
641
637 ## Execute custom bootstrap scripts
642 ## Execute custom bootstrap scripts
638 if [ -d "custom.d" ] ; then
643 if [ -d "custom.d" ] ; then
639 for SCRIPT in custom.d/*.sh; do
644 for SCRIPT in custom.d/*.sh; do
640 . "$SCRIPT"
645 . "$SCRIPT"
641 done
646 done
642 fi
647 fi
643
648
644 # Execute custom scripts inside the chroot
649 # Execute custom scripts inside the chroot
645 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
650 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
646 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
651 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
647 chroot_exec /bin/bash -x <<'EOF'
652 chroot_exec /bin/bash -x <<'EOF'
648 for SCRIPT in /chroot_scripts/* ; do
653 for SCRIPT in /chroot_scripts/* ; do
649 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
654 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
650 $SCRIPT
655 $SCRIPT
651 fi
656 fi
652 done
657 done
653 EOF
658 EOF
654 rm -rf "${R}/chroot_scripts"
659 rm -rf "${R}/chroot_scripts"
655 fi
660 fi
656
661
657 # Remove c/c++ build environment from the chroot
662 # Remove c/c++ build environment from the chroot
658 chroot_remove_cc
663 chroot_remove_cc
659
664
660 # Generate required machine-id
665 # Generate required machine-id
661 MACHINE_ID=$(dbus-uuidgen)
666 MACHINE_ID=$(dbus-uuidgen)
662 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
667 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
663 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
668 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
664
669
665 # APT Cleanup
670 # APT Cleanup
666 chroot_exec apt-get -y clean
671 chroot_exec apt-get -y clean
667 chroot_exec apt-get -y autoclean
672 chroot_exec apt-get -y autoclean
668 chroot_exec apt-get -y autoremove
673 chroot_exec apt-get -y autoremove
669
674
670 # Unmount mounted filesystems
675 # Unmount mounted filesystems
671 umount -l "${R}/proc"
676 umount -l "${R}/proc"
672 umount -l "${R}/sys"
677 umount -l "${R}/sys"
673
678
674 # Clean up directories
679 # Clean up directories
675 rm -rf "${R}/run/*"
680 rm -rf "${R}/run/*"
676 rm -rf "${R}/tmp/*"
681 rm -rf "${R}/tmp/*"
677
682
678 # Clean up files
683 # Clean up files
679 rm -f "${ETC_DIR}/ssh/ssh_host_*"
684 rm -f "${ETC_DIR}/ssh/ssh_host_*"
680 rm -f "${ETC_DIR}/dropbear/dropbear_*"
685 rm -f "${ETC_DIR}/dropbear/dropbear_*"
681 rm -f "${ETC_DIR}/apt/sources.list.save"
686 rm -f "${ETC_DIR}/apt/sources.list.save"
682 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
687 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
683 rm -f "${ETC_DIR}/*-"
688 rm -f "${ETC_DIR}/*-"
684 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
689 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
685 rm -f "${ETC_DIR}/resolv.conf"
690 rm -f "${ETC_DIR}/resolv.conf"
686 rm -f "${R}/root/.bash_history"
691 rm -f "${R}/root/.bash_history"
687 rm -f "${R}/var/lib/urandom/random-seed"
692 rm -f "${R}/var/lib/urandom/random-seed"
688 rm -f "${R}/initrd.img"
693 rm -f "${R}/initrd.img"
689 rm -f "${R}/vmlinuz"
694 rm -f "${R}/vmlinuz"
690 rm -f "${R}${QEMU_BINARY}"
695 rm -f "${R}${QEMU_BINARY}"
691
696
692 if [ "$ENABLE_QEMU" = true ] ; then
697 if [ "$ENABLE_QEMU" = true ] ; then
693 # Setup QEMU directory
698 # Setup QEMU directory
694 mkdir "${BASEDIR}/qemu"
699 mkdir "${BASEDIR}/qemu"
695
700
696 # Copy kernel image to QEMU directory
701 # Copy kernel image to QEMU directory
697 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
702 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
698
703
699 # Copy kernel config to QEMU directory
704 # Copy kernel config to QEMU directory
700 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
705 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
701
706
702 # Copy kernel dtbs to QEMU directory
707 # Copy kernel dtbs to QEMU directory
703 for dtb in "${BOOT_DIR}/"*.dtb ; do
708 for dtb in "${BOOT_DIR}/"*.dtb ; do
704 if [ -f "${dtb}" ] ; then
709 if [ -f "${dtb}" ] ; then
705 install_readonly "${dtb}" "${BASEDIR}/qemu/"
710 install_readonly "${dtb}" "${BASEDIR}/qemu/"
706 fi
711 fi
707 done
712 done
708
713
709 # Copy kernel overlays to QEMU directory
714 # Copy kernel overlays to QEMU directory
710 if [ -d "${BOOT_DIR}/overlays" ] ; then
715 if [ -d "${BOOT_DIR}/overlays" ] ; then
711 # Setup overlays dtbs directory
716 # Setup overlays dtbs directory
712 mkdir "${BASEDIR}/qemu/overlays"
717 mkdir "${BASEDIR}/qemu/overlays"
713
718
714 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
719 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
715 if [ -f "${dtb}" ] ; then
720 if [ -f "${dtb}" ] ; then
716 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
721 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
717 fi
722 fi
718 done
723 done
719 fi
724 fi
720
725
721 # Copy u-boot files to QEMU directory
726 # Copy u-boot files to QEMU directory
722 if [ "$ENABLE_UBOOT" = true ] ; then
727 if [ "$ENABLE_UBOOT" = true ] ; then
723 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
728 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
724 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
729 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
725 fi
730 fi
726 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
731 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
727 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
732 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
728 fi
733 fi
729 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
734 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
730 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
735 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
731 fi
736 fi
732 fi
737 fi
733
738
734 # Copy initramfs to QEMU directory
739 # Copy initramfs to QEMU directory
735 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
740 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
736 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
741 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
737 fi
742 fi
738 fi
743 fi
739
744
740 # Calculate size of the chroot directory in KB
745 # Calculate size of the chroot directory in KB
741 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
746 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
742
747
743 # Calculate the amount of needed 512 Byte sectors
748 # Calculate the amount of needed 512 Byte sectors
744 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
749 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
745 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
750 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
746 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
751 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
747
752
748 # The root partition is EXT4
753 # The root partition is EXT4
749 # This means more space than the actual used space of the chroot is used.
754 # This means more space than the actual used space of the chroot is used.
750 # As overhead for journaling and reserved blocks 35% are added.
755 # As overhead for journaling and reserved blocks 35% are added.
751 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
756 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
752
757
753 # Calculate required image size in 512 Byte sectors
758 # Calculate required image size in 512 Byte sectors
754 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
759 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
755
760
756 # Prepare image file
761 # Prepare image file
757 if [ "$ENABLE_SPLITFS" = true ] ; then
762 if [ "$ENABLE_SPLITFS" = true ] ; then
758 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
763 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
759 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
764 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
760 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
765 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
761 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
766 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
762
767
763 # Write firmware/boot partition tables
768 # Write firmware/boot partition tables
764 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
769 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
765 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
770 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
766 EOM
771 EOM
767
772
768 # Write root partition table
773 # Write root partition table
769 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
774 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
770 ${TABLE_SECTORS},${ROOT_SECTORS},83
775 ${TABLE_SECTORS},${ROOT_SECTORS},83
771 EOM
776 EOM
772
777
773 # Setup temporary loop devices
778 # Setup temporary loop devices
774 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
779 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
775 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
780 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
776 else # ENABLE_SPLITFS=false
781 else # ENABLE_SPLITFS=false
777 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
782 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
778 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
783 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
779
784
780 # Write partition table
785 # Write partition table
781 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
786 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
782 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
787 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
783 ${ROOT_OFFSET},${ROOT_SECTORS},83
788 ${ROOT_OFFSET},${ROOT_SECTORS},83
784 EOM
789 EOM
785
790
786 # Setup temporary loop devices
791 # Setup temporary loop devices
787 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
792 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
788 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
793 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
789 fi
794 fi
790
795
791 if [ "$ENABLE_CRYPTFS" = true ] ; then
796 if [ "$ENABLE_CRYPTFS" = true ] ; then
792 # Create dummy ext4 fs
797 # Create dummy ext4 fs
793 mkfs.ext4 "$ROOT_LOOP"
798 mkfs.ext4 "$ROOT_LOOP"
794
799
795 # Setup password keyfile
800 # Setup password keyfile
796 touch .password
801 touch .password
797 chmod 600 .password
802 chmod 600 .password
798 echo -n ${CRYPTFS_PASSWORD} > .password
803 echo -n ${CRYPTFS_PASSWORD} > .password
799
804
800 # Initialize encrypted partition
805 # Initialize encrypted partition
801 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
806 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
802
807
803 # Open encrypted partition and setup mapping
808 # Open encrypted partition and setup mapping
804 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
809 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
805
810
806 # Secure delete password keyfile
811 # Secure delete password keyfile
807 shred -zu .password
812 shred -zu .password
808
813
809 # Update temporary loop device
814 # Update temporary loop device
810 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
815 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
811
816
812 # Wipe encrypted partition (encryption cipher is used for randomness)
817 # Wipe encrypted partition (encryption cipher is used for randomness)
813 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
818 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
814 fi
819 fi
815
820
816 # Build filesystems
821 # Build filesystems
817 mkfs.vfat "$FRMW_LOOP"
822 mkfs.vfat "$FRMW_LOOP"
818 mkfs.ext4 "$ROOT_LOOP"
823 mkfs.ext4 "$ROOT_LOOP"
819
824
820 # Mount the temporary loop devices
825 # Mount the temporary loop devices
821 mkdir -p "$BUILDDIR/mount"
826 mkdir -p "$BUILDDIR/mount"
822 mount "$ROOT_LOOP" "$BUILDDIR/mount"
827 mount "$ROOT_LOOP" "$BUILDDIR/mount"
823
828
824 mkdir -p "$BUILDDIR/mount/boot/firmware"
829 mkdir -p "$BUILDDIR/mount/boot/firmware"
825 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
830 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
826
831
827 # Copy all files from the chroot to the loop device mount point directory
832 # Copy all files from the chroot to the loop device mount point directory
828 rsync -a "${R}/" "$BUILDDIR/mount/"
833 rsync -a "${R}/" "$BUILDDIR/mount/"
829
834
830 # Unmount all temporary loop devices and mount points
835 # Unmount all temporary loop devices and mount points
831 cleanup
836 cleanup
832
837
833 # Create block map file(s) of image(s)
838 # Create block map file(s) of image(s)
834 if [ "$ENABLE_SPLITFS" = true ] ; then
839 if [ "$ENABLE_SPLITFS" = true ] ; then
835 # Create block map files for "bmaptool"
840 # Create block map files for "bmaptool"
836 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
841 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
837 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
842 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
838
843
839 # Image was successfully created
844 # Image was successfully created
840 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
845 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
841 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
846 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
842 else
847 else
843 # Create block map file for "bmaptool"
848 # Create block map file for "bmaptool"
844 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
849 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
845
850
846 # Image was successfully created
851 # Image was successfully created
847 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
852 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
848
853
849 # Create qemu qcow2 image
854 # Create qemu qcow2 image
850 if [ "$ENABLE_QEMU" = true ] ; then
855 if [ "$ENABLE_QEMU" = true ] ; then
851 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
856 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
852 QEMU_SIZE=16G
857 QEMU_SIZE=16G
853
858
854 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
859 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
855 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
860 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
856
861
857 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
862 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
858 fi
863 fi
859 fi
864 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant